﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using Uccelerate.Helpers;
using Uccelerate.Requests;
using UCommerce.Api;
using Umbraco.Web.WebApi;

namespace UccelerateApi
{

    public class PlaceOrderResponse 
    {
        public List<string> ErrorList { get; set; }
      
    }
    public class OrderController : UmbracoApiController
    {

        [HttpPost]
        public PlaceOrderResponse Submit(PlaceOrderRequest request)
        {

            var ErrorList = CommerceHelper.ValidateOrderRequest(request);

            if (ErrorList.Any())
            {
                return new PlaceOrderResponse() { ErrorList = ErrorList };
            }

            //if we have seperate shipping address, set it here. Else set it to the same as Billing
            if (request.OtherShippingAddress) {
                TransactionLibrary.EditShippingInformation(
                    request.ShippingFirstName,
                    request.ShippingLastName,
                    request.ShippingEmail,
                    request.ShippingPhone,
                    request.ShippingPhone,
                    request.ShippingCompany,
                    request.ShippingAddress,
                    request.ShippingSecondAddress == null ? "" : request.ShippingSecondAddress,
                    request.ShippingPostalCode,
                    request.ShippingCity,
                    request.ShippingState == null ? "" : request.ShippingState,
                    request.ShippingAttention,
                    Int32.Parse(request.ShippingCountryId));
            }
            else { 
                TransactionLibrary.EditShippingInformation(
                  request.FirstName,
                  request.LastName,
                  request.Email,
                  request.Phone,
                  request.Phone,
                  request.Company,
                  request.Address,
                  request.SecondAddress == null ? "" : request.SecondAddress,
                  request.PostalCode,
                  request.City,
                  request.State == null ? "" : request.State,
                  request.Attention,
                  Int32.Parse(request.CountryId));
            }

            TransactionLibrary.EditBillingInformation(
              request.FirstName,
              request.LastName,
              request.Email,
              request.Phone,
              request.Phone,
              request.Company,
              request.Address,
              request.SecondAddress == null ? "" : request.SecondAddress,
              request.PostalCode,
              request.City,
              request.State == null ? "" : request.State,
              request.Attention,
              Int32.Parse(request.CountryId));

            TransactionLibrary.ExecuteBasketPipeline();
           
            return new PlaceOrderResponse();
        }
    }
}

