﻿using Uccelerate.Helpers;
using Uccelerate.Services.Model;
using System.Globalization;
using System.Threading;
using System.Web.Http;
using Umbraco.Web.WebApi;

namespace UccelerateApi
{

    public class GetProduct
    {
        public string ProductId { get; set; }
        public string Culture { get; set; }
        public string BaseUrl { get; set; }
        public int SiteId { get; set; }
    }

    public class GetProductResponse
    {
        public ProductVariation Product { get; set; }
    }

    public class ProductController : UmbracoApiController
    {
        [HttpPost]
        public GetProductResponse GetProduct(GetProduct request)
        {
            var response = new GetProductResponse();

            //culture info
            CultureInfo ci = new CultureInfo(request.Culture);
            Thread.CurrentThread.CurrentCulture = ci;
            Thread.CurrentThread.CurrentUICulture = ci;
            var site = Umbraco.TypedContent(request.SiteId);

            string ProductId = request.ProductId;

            var product = ProductHelper.GetProductById(ProductId);
            response.Product = Uccelerate.Public.Helpers.BuildProductModel(product, request.Culture, request.BaseUrl, true, site);

            return response;
        }
    }
}
