﻿using System.Collections.Generic;
using Uccelerate.Helpers;
using Uccelerate.Services.Model;
using System.Globalization;
using System.Threading;
using System.Web.Http;
using Umbraco.Web.WebApi;

namespace UccelerateApi
{
        public class GetProductList
        {
            public string ProductIds { get; set; }
            public string Culture { get; set; }
            public string BaseUrl { get; set; }
            public int SiteId { get; set; }
        }

        public class ProductListResponse
        {
            public ICollection<ProductVariation> Products { get; set; }
            public int TotalResults { get; set; }
        }

        public class ProductListController : UmbracoApiController
        {
            [HttpPost]
            public ProductListResponse GetProductList(GetProductList request)
            {

                var response = new ProductListResponse();

                //culture info
                CultureInfo ci = new CultureInfo(request.Culture);
                Thread.CurrentThread.CurrentCulture = ci;
                Thread.CurrentThread.CurrentUICulture = ci;
                var site = Umbraco.TypedContent(request.SiteId);

                string[] ProductIdList = request.ProductIds.Split(',');    
                response.Products = new List<ProductVariation>();


                foreach (var productId in ProductIdList)
                {
                    var product = ProductHelper.GetProductById(productId);

                    var productModel = Uccelerate.Public.Helpers.BuildProductModel(product, request.Culture, request.BaseUrl, false, site);

                    if (productModel != null)
                        response.Products.Add(productModel);
                }          

                return response;
            }

    }

   
}
