﻿using System.Web.Http;
using UCommerce.Api;
using UCommerce.EntitiesV2;
using umbraco;
using Umbraco.Web.WebApi;

namespace UccelerateApi
{
    public class SetVoucherRequest
    {
        public string VoucherCode { get; set; }
    }
    public class SetVoucherResponse
    {
        public string Message { get; set; }
        public bool Success { get; set; }
    }
    public class VoucherController : UmbracoApiController
    {
        [HttpPost]
        public SetVoucherResponse Set(SetVoucherRequest request)
        {
            var PurchaseOrder = TransactionLibrary.GetBasket().PurchaseOrder;
            var addedVoucher = MarketingLibrary.AddVoucher(request.VoucherCode);
            PurchaseOrder.Save();
            TransactionLibrary.ExecuteBasketPipeline();

            if(addedVoucher)
                return new SetVoucherResponse(){ Message = library.GetDictionaryItem("VoucherSuccess"), Success = addedVoucher};

            return new SetVoucherResponse() { Message = library.GetDictionaryItem("VoucherError"), Success = addedVoucher };
        }
    }
}

