angular.module("umbraco").controller("IconPicker.Controller", function ($scope, $http, assetsService, /*dialogService,*/ notificationsService) {
	////////////////
	// Setup
	////////////////
	
	$scope.icons = [];
  $scope.IconSets = {

    "Solid": {
      cssPath: "/App_Plugins/iconpicker/icons-regular.css",
      cssRegexPattern: "(fa-[^:]*?):before",
      iconPattern: '<i class="fa {0}"></i>'
    },
    "Brands": {
      cssPath: "/App_Plugins/iconpicker/icons-brands.css",
      cssRegexPattern: "(fa-[^:]*?):before",
      iconPattern: '<i class="fab {0}"></i>'
    }
  };

  $scope.IconType = $scope.IconSets["Solid"];

	$scope.overlay = {
		view: '/app_plugins/iconpicker/dialogs/iconpicker.dialog.html',
		width: 500,
		show: false,
		title: 'Select an icon',
		selectIcon: function(icon) {
			$scope.overlay.show = false;
			$scope.model.value = icon;
		},
		close: function() {
			$scope.overlay.show = false;
    },
    iconType: $scope.IconType,
    iconSets: $scope.IconSets,
    pickIconSet: function (iconType) {
      $scope.IconType = iconType;
      $scope.GetIcons();
    }
	};

	//////////////////////
	// Private functions
	//////////////////////
	
	// Get the matching class names from the stylesheet
 $scope.GetIcons = function () {

   var cssRegex = new RegExp($scope.IconType.cssRegexPattern, 'g');
		var matches = [];
		var isError = false;

 
		// Get the class names from the specified stylesheet,
		// use angular http request to make a cached request for the stylesheet content.
		$http({
			method: 'GET', 
      url: $scope.IconType.cssPath,
			cache: true
		})
		.success(function (data, status, headers, config) {
			var cssText = data;
			var hasMatches = cssRegex.test(cssText);

			//reset regex
      cssRegex.compile($scope.IconType.cssRegexPattern, "g");

			if (hasMatches) {
				var match = cssRegex.exec(cssText);

				while (match != null) {
					match = cssRegex.exec(cssText);

					// check if match has populated array
					if (match != null && match.length > 1) {
						//check if array already contains match and not on exclude list
						if (!(matches.indexOf(match[1]) > 0)) {
							matches.push(match[1]);
							hasMatches = true;
						}
					}
				}
			}

			matches.sort();

			if (!hasMatches && !isError) {
				isError = true;

				notificationsService.error('An error has occured.', 'No matches in stylesheet for regex: ' + cssRegexPattern);
			}
		})
		.error(function (data, status, headers, config) {
			notificationsService.error('An error has occured.', 'Stylesheet or file ' + cssPath + ' not found on server.');
			isError = true;
		});

    var cssPath = "";

    if (!/css$/.test($scope.IconType.cssPath)) {
      cssPath = $scope.IconType.cssPath.split('.')[0] + '.css';
		}

		// Load the supplied css stylesheet using the umbraco assetsService
		assetsService.loadCss(cssPath);

    $scope.icons = matches;
    $scope.model.icons = matches;
    $scope.overlay.icons = matches;
    };


	//////////////////////
	// Scope functions
	//////////////////////
	
	$scope.openIconPickerDialog = function() {
		$scope.overlay.show = true;
		$scope.overlay.icons = $scope.icons;
		$scope.overlay.renderIconPattern = $scope.renderIconPattern;
    $scope.overlay.iconPattern = $scope.IconType.iconPattern;
	};

	// Write out the HTML for the current element class name using the icon pattern.
  $scope.renderIconPattern = function (currentClassName) {
      return $scope.IconType.iconPattern.replace("{0}", currentClassName);
	};

	$scope.remove = function() {
		$scope.model.value = '';
	};


	//////////////
	// Load
	//////////////

  $scope.GetIcons();
});
