/*
 Uccelerate - 0.3.0
*/

Vue.directive('init', {
    bind: function(el, binding) {
    }
});

Vue.directive('imagesLoaded', window.VueImagesLoaded)

var app = new Vue({
  el: '#uccelerate',
  data: {
    PickedCurrency: '',
    BasketCount: 0,
    MobileNavVisible: false,
    SearchModalVisible: false,
    MiniCartVisible: false,
    FilterVisible: false,
    VueInititiated: true,
    showCookieConsent: true
  },
  methods: {
     scrollToTop: function(){
        Helpers.scrollToTop();
     },
     cookieConsent: function(){
        this.showCookieConsent = false;
        Helpers.setCookie("cookie-consent", "true", 365);
     },
     toggleMenuLevel: function(e){
        var btn = e.currentTarget;
        var container = btn.parentElement.parentElement.getElementsByTagName("ul")[0];
        
    	if (!container.classList.contains('active')) {
            container.classList.add('active');
            container.style.display = 'block';
            btn.classList.add('open');
        } 
        else {
            container.classList.remove('active');
            container.style.display = 'none';
            btn.classList.remove('open');
        }
     },
     galleryItemClick: function(e){
         e.preventDefault();
        
         var getItems = function(gallery) {
            var items = [],
                links = gallery.getElementsByTagName('a');
            for(var j = 0; j < links.length; j++) {
                var href   = links[j].getAttribute('href'),
                    size   = links[j].getAttribute('data-size').split('x'),
                    width  = size[0],
                    height = size[1];

                var item = {
                    src : href,
                    w   : width,
                    h   : height
                };

                items.push(item);
            }
            return items;
        };
         
         var pswp = document.getElementsByClassName("pswp")[0];
         var items = getItems(e.target.parentNode.parentNode.parentNode.parentNode);

            var index = Helpers.indexInParent(e.target.parentNode.parentNode);
          var options = {
              index: index,
              bgOpacity: 0.9,
              showHideOpacity: true,
              shareEl: false,
              getThumbBoundsFn: function($index) {
                var thumbnail = document.querySelectorAll('.gallery-item img')[index];
                var pageYScroll = window.pageYOffset || document.documentElement.scrollTop;
                var rect = thumbnail.getBoundingClientRect(); 
                return {x:rect.left, y:rect.top + pageYScroll, w:rect.width};
            }
          };

          // Initialize PhotoSwipe
          var lightBox = new PhotoSwipe(pswp, PhotoSwipeUI_Default, items, options);
          lightBox.init();
     },
     initGoogleMaps: function(){
         
        var map = document.querySelectorAll(".map-canvas");
    
        if (map.length){
           for(i = 0; i < map.length; i++){
              var mapCanvas = map[i],
                 lat = map[i].getAttribute("data-lat"),
                 long = map[i].getAttribute("data-long"),
                 pin = map[i].getAttribute("data-pin"),
                 zoom = parseInt(map[i].getAttribute("data-zoom"));
        
              var mapOptions = {
                 center: new google.maps.LatLng(lat, long),
                 zoom: zoom,
                 scrollwheel: false
              };
        
              var mapobj = new google.maps.Map(mapCanvas, mapOptions);
        
              if(pin == "no"){
                 var marker = new google.maps.Marker({
                    position: new google.maps.LatLng(lat, long),
                    map: mapobj
                 });
              }
              else{
                 var image = {
                    url: pin,
                    scaledSize: new google.maps.Size(50, 50),
                 };
                 var marker = new google.maps.Marker({
                    position: new google.maps.LatLng(lat, long),
                    map: mapobj,
                    optimized: false,
                    icon: image
                 });
              }
           }
        }
     },
     toggleAccordion: function(e){
        var el = e.currentTarget.parentElement;
        el.classList.toggle('open');
     },
     toggleHeroVideoSound: function(e){
        var btn = e.currentTarget;
        var video = btn.parentElement.querySelector(".hero-video__player");
        btn.classList.toggle('sound-on');
        video.muted = !video.muted;
     }
   },
   mounted: function () {
    lazySizes.init();
    this.initGoogleMaps();
    
    this.VueInititiated = true;
    var obj = this;
    
    this.$root.$on('closeMiniCart', function() {
        obj.MiniCartVisible = false;
    });
    
    this.$root.$on('openMiniCart', function() {
        obj.MiniCartVisible = true;
    });
    
    this.$root.$on('closeFilter', function() {
        obj.FilterVisible = false;
    });
    
    this.$root.$on('openFilter', function() {
        obj.FilterVisible = true;
    });
    
    if(Helpers.getCookie("cookie-consent") != ""){
        this.showCookieConsent = false;
    }
        
    //Navigation touch support
    (function(){
        var items = document.querySelectorAll(".main-nav ul li a");
        
        items.forEach(function(el) {
            
            el.addEventListener("touchstart", function(e) {
                     
                var a = e.currentTarget;
                var navLi = a.parentElement;
                var dropExist = navLi.querySelector('ul');
                var navAllLi = document.querySelectorAll(".main-nav li");
                
                if(!navLi.classList.contains('touch-open') && dropExist && window.outerWidth > 992){
                    e.preventDefault();
                    var parentLi = navLi.closest(".touch-open");
                    
                    navAllLi.forEach(function(liel) {
                        if(parentLi != liel)
                            liel.classList.remove('touch-open');
                    });
                    navLi.classList.add('touch-open');
                    
                }
                else{
                    navAllLi.forEach(function(liel) {
                        liel.classList.remove('touch-open');
                    });
                }
                
            });
        });
        
    })();

    
  }
});