Vue.component('checkout', {
  props: ['culture', 'defaultCountry', 'siteId'],
  data: function () {
    return {
      basket: {
        LineItems: []
      },
      CheckoutForm: {},
      ShowVoucherField: false,
      VoucherCodeInput: '',
      CheckoutLoading: true,
      discounts: [],
      shippingMethods: [],
      paymentMethods: [],
      products: []
    }
  },
  mounted: function () {
    this.CheckoutForm.CountryId = this.defaultCountry;  
    
    this.getBasket();
    this.getShippingAndPaymentMethods(true, true);
  },
  methods: {
    getBasket: function () {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Get", { Culture: this.culture, SiteId: this.siteId }).then(function (response) {
        obj.basket = response.data.Basket;
      });
    },
    removeLineItem: function (id) {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Update", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
        obj.getBasket();
      });
    },
    updateLineItem: function (id, amount) {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Update", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
        obj.getBasket();
        obj.setPaymentAndShipping(); //Update payment with new basket
      });
    },
    updateShippingCountry: function () {
      this.getShippingAndPaymentMethods(false, true);
    },
    getShippingAndPaymentMethods: function (UpdatePayment, UpdateShipping) {
        var obj = this
        if (typeof this.CheckoutForm.CountryId != "undefined"){

           axios.post("/Umbraco/Api/Checkout/GetShippingAndPaymentMethods", { CountryId: parseInt(this.CheckoutForm.CountryId), Culture: this.Culture }).then(function (response) {
               obj.shippingMethods = response.data.ShippingMethods;
               obj.paymentMethods = response.data.PaymentMethods;

                if (UpdateShipping) {
                  if (obj.shippingMethods.length > 0) {
                    
                    obj.CheckoutForm.shippingSelection = String(obj.shippingMethods[0].Id);
                  } else {
                    console.error("Could not find any shipping methods. Please make sure you have configured your shop correctly.");
                  }
                }        
 
                if (UpdatePayment) {
                  if (obj.paymentMethods.length > 0) {
                    obj.CheckoutForm.paymentSelection = String(obj.paymentMethods[0].Id);
                    obj.CheckoutForm.paymentSelectionLabel = String(obj.paymentMethods[0].Name);
                  } else {
                    console.error("Could not find any payment methods. Please make sure you have configured your shop correctly.");
                  }
                }

                if (UpdateShipping && UpdatePayment) {
                  obj.setPaymentAndShipping();
                }

                obj.CheckoutLoading = false;
            });
        }
    },
    setPaymentMethod: function(method){
        this.CheckoutForm.paymentSelection = method.Id;
    },
    setPaymentAndShipping: function(){
        var obj = this;
        axios.post("/Umbraco/Api/Checkout/SetPaymentAndShipping", { ShipmentId: parseInt(this.CheckoutForm.shippingSelection), PaymentId: parseInt(this.CheckoutForm.paymentSelection), CountryId: parseInt(this.CheckoutForm.CountryId) }).then(function (response) {
         obj.getBasket();
         obj.discounts = response.data.Discounts;
      
         obj.getShippingAndPaymentMethods(false, false);
     
        });
    },
    placeOrder: function () {
      axios.post("/Umbraco/Api/Order/Submit", this.CheckoutForm).then(function (response) {
        window.location.href = window.location.href+"?payment=1"
      });
    },
    setVoucher: function () {
      var obj = this;
      axios.post("/Umbraco/Api/Voucher/Set", { VoucherCode: this.VoucherCodeInput }).then(function (response) {
        obj.getBasket();
        obj.updateCheckout(false, false);
      });
    }
  }
});