/*======================================
  #Set os/browser classes
======================================*/
navigator.browserSpecs = (function(){
    var ua= navigator.userAgent, tem,
    M= ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if(/trident/i.test(M[1])){
        tem=  /\brv[ :]+(\d+)/g.exec(ua) || [];
        return {name:'IE',version:(tem[1] || '')};
    }
    if(M[1]=== 'Chrome'){
        tem= ua.match(/\b(OPR|Edge)\/(\d+)/);
        if(tem!= null) return {name:tem[1].replace('OPR', 'Opera'),version:tem[2]};
    }
    M= M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
    if((tem= ua.match(/version\/(\d+)/i))!= null) M.splice(1, 1, tem[1]);
    return {name:M[0],version:M[1]};
})();

(function(){
   var OSName = "os";
   var body =  document.body;
   if (navigator.appVersion.indexOf("Win")!=-1) OSName="windows";
   else if (navigator.appVersion.indexOf("Mac")!=-1) OSName="macos";
   else if (navigator.appVersion.indexOf("X11")!=-1) OSName="unix";
   else if (navigator.appVersion.indexOf("Linux")!=-1) OSName="linux";
   body.classList.add(OSName);

   if((navigator.userAgent.indexOf("Opera") || navigator.userAgent.indexOf('OPR')) != -1 ) { body.classList.add('browser-opera'); }
   else if(navigator.userAgent.indexOf("Chrome") != -1 ) { body.classList.add('browser-chrome'); }
   else if(navigator.userAgent.indexOf("Safari") != -1) { body.classList.add('browser-safari'); }
   else if(navigator.userAgent.indexOf("Firefox") != -1 ) { body.classList.add('browser-firefox'); }
   else if((navigator.userAgent.indexOf("MSIE") != -1 ) || (!!document.documentMode == true )){ body.classList.add('browser-explorer'); }
   else if(navigator.userAgent.indexOf("Edge") != -1 ) { body.classList.add('browser-edge'); }
   if(navigator.browserSpecs.version){ body.classList.add('browser-version-'+navigator.browserSpecs.version); }

   var el = document.createElement('div');
   el.setAttribute('ongesturestart', 'return;');
   if(typeof el.ongesturestart == "function"){ body.classList.add("touch"); }
   else { body.classList.add("no-touch"); }
})();

/*======================================
  #Set .scroll class on scroll
======================================*/
(function(){
   window.addEventListener('scroll', function() {
      if(pageYOffset > 1){ document.body.classList.add("scroll"); }
      else{ document.body.classList.remove("scroll");  }
   });
})();

/*======================================
  #Fluidvids - Responsive video
======================================*/
fluidvids.init({
  selector: ['iframe', 'object'],
  players: ['www.youtube.com', 'player.vimeo.com'] // players to support
});

/*======================================
  #Share modals
======================================*/
function PopupCenter(url, title, w, h) {
    var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
    var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

    var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
    var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

    var left = ((width / 2) - (w / 2)) + dualScreenLeft;
    var top = ((height / 2) - (h / 2)) + dualScreenTop;
    var newWindow = window.open(url, title, 'scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

    if (window.focus) {
        newWindow.focus();
    }
}

/*======================================
  #Instagram
======================================*/
(function(){
    var instafeed = document.querySelectorAll("#instafeed");
    
    if (instafeed.length){
       for(i = 0; i < instafeed.length; i++){
          var wrap = instafeed[i],
             count = instafeed[i].getAttribute("data-count"),
             link = instafeed[i].getAttribute("data-link"),
             icon = instafeed[i].getAttribute("data-icon"),
             token = instafeed[i].getAttribute("data-token"),
             user = instafeed[i].getAttribute("data-user"),
             username = instafeed[i].getAttribute("data-username"),
             imagewidth = instafeed[i].getAttribute("data-imagewidth"),
             emplate = "",
             linkstart = "",
             linkend = "",
             iconlink = "";
    
             if(link == "1"){
              linkstart = '<a href="{{link}}" class="instagram-image-link" target="_blank">';
              linkend = '</a>';
             }
    
             if(icon == "1"){
              iconlink = '<a target="_blank" class="instagram-user-link" href="https://www.instagram.com/'+ username +'"><i class="fab fa-instagram"></a></i>';
             }
    
             template = '<div class="col-'+ imagewidth +'"><div class="gallery-item"><figure>'+iconlink+''+linkstart+'<span class="bg" style="display:block;background-size:cover;background-position:center; padding-top: 100%; width: 100%; height: 100% ;background-image: url({{image}});" alt="{{caption}}"></span>'+linkend+'</figure></div></div>';
    
             // Get images
             var feed = new Instafeed({
                userId: user,
                accessToken: token,
                get: 'user',
                limit: count,
                template: template,
                resolution: 'standard_resolution'
               });
    
             feed.run();
       }
    }
})();

/*======================================
  #Page loaded 
======================================*/
window.addEventListener('load', function() {
  document.body.classList.remove("page-loading");
  document.body.classList.add("page-loaded");
});

