Vue.component('minicart', {
  props: ['culture', 'siteId'],
  data: function () {
    return {
      basket: {
        LineItems: []
      },
      openCart: true
    }
  },
  mounted: function () {
    this.getBasket();
    var obj = this;
    
    //update markup
    this.$root.$on('updateMiniCart', function() {
        obj.getBasket();
    });
  },
  methods: {
    getBasket: function () {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Get", { Culture: this.culture, SiteId: this.siteId }).then(function (response) {
        obj.basket = response.data.Basket;
        obj.$root.BasketCount = obj.basket.TotalItems;
      });
    },
    removeLineItem: function (id) {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Update", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
        obj.getBasket();
      });
    },
    updateLineItem: function (id, amount) {
      var obj = this;
      axios.post("/Umbraco/Api/Basket/Update", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
        obj.getBasket();
      });
    },
    closeMiniCart: function(){
        this.$root.$emit('closeMiniCart');
    }
  }

});